/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg.cachingdemo;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

/**
 *
 * @author omozegieaziegbe
 */
@RestController
public class CachingController {
    
private static final Logger logger = LoggerFactory.getLogger(CachingController.class);  

private final CachingService cachingService;

    @Autowired
    public CachingController(CachingService cachingService) {
        this.cachingService = cachingService;
    }

    @GetMapping("/calculateSquare/{number}")
    public int calculateSquare(@PathVariable int number) {
        logger.debug("Invoking calculateSquare method for number: {}", number);
        return cachingService.calculateSquare(number);
    }

    @GetMapping("/getCachedSquare/{number}")
    public int getCachedSquare(@PathVariable int number) {
        logger.debug("Invoking getCachedSquare method for number: {}", number);
        return cachingService.getCachedSquare(number);
    }
}