/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg.cachingdemo;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Scope;
import org.springframework.context.annotation.ScopedProxyMode;
import org.springframework.stereotype.Service;

/**
 *
 * @author omozegieaziegbe
 */
@Service
@Scope(proxyMode = ScopedProxyMode.TARGET_CLASS)
public class CachingService {

    private static final Logger logger = LoggerFactory.getLogger(CachingService.class);

    
    @Cacheable("myCache")
    public int calculateSquare(int number) {
        logger.info("Calculating square for number: {}", number);
        // Simulate time-consuming operation
        try {
            Thread.sleep(2000); // Simulate delay
        } catch (InterruptedException e) {
            Thread.currentThread().interrupt();
        }
        return number * number;
    }

    public int getCachedSquare(int number) {
        logger.info("Invoking getCachedSquare method for number: {}", number);
        return calculateSquare(number); // This will invoke @Cacheable method
    }
    
//    public int getSquare(int number) {
//        logger.info("Invoking getCachedSquare method for number: {}", number);
//        return this.calculateSquare(number);
//    }
}